"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setConfig = setConfig;
exports.getConfig = getConfig;
exports.changeConfig = changeConfig;

var _lodash = _interopRequireDefault(require("lodash"));

var _os = _interopRequireDefault(require("os"));

var defaultSettings = {
  'host': _os.default.hostname(),
  'validateInputs': {
    'email': function email(check) {
      return check.isEmail();
    },
    'password': function password(check) {
      return check.isMD5();
    }
  },
  'loginWith': {
    'email': 1
  },
  'database': {
    'library': 'typeorm'
  },
  'log': function log(data) {//do something
  },
  'mailTransport': {
    'service': 'gmail',
    'auth': {
      'user': process.env.MAIL_USERNAME || '',
      'pass': process.env.MAIL_PASSWORD || ''
    }
  },
  'functions': {
    'default': {
      'actions': {
        'login': function login(req, res) {
          req.token().generate(req.body.device).then(function (ret) {
            ret.disable.exceptMe();
            res.json({
              "error": false,
              "response": {
                "token": ret.token
              }
            });
          }).catch(function (err) {
            console.error(err);
            res.send("fail doJWTLogin");
          });
        }
      }
    }
  }
};
var settings = defaultSettings;

function setConfig(cnf) {
  settings = _lodash.default.merge(defaultSettings, cnf);

  if (typeof settings.loginWith === 'string') {
    var objectLoginWIth = {};
    objectLoginWIth[settings.loginWith] = 1;
    settings.loginWith = objectLoginWIth;
  }
}

function getConfig(key) {
  return key ? _lodash.default.get(settings, key) : settings;
}

function changeConfig(key, value) {
  _lodash.default.set(settings, key, value);
}