"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _config = require("./config");

var library = null;
/**
 * Get the database driver by database.tpye in config
 */

function _default() {
  var databaseName = (0, _config.getConfig)('database.library');

  if (!databaseName) {
    console.error('Database type not set!');
    process.exit();
  }

  switch (databaseName) {
    case 'mongoose':
      if (!library) library = require('./database/mongoose').default;
      break;

    case 'typeorm':
      if (!library) library = require('./database/typeorm').default;
      break;

    default:
      console.error('Invalid database type!');
      process.exit();
  }

  return library();
}