"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _mongoose = _interopRequireDefault(require("mongoose"));

var _account = _interopRequireDefault(require("./mongoose/repositories/account"));

var _device = _interopRequireDefault(require("./mongoose/repositories/device"));

var _identity = _interopRequireDefault(require("./mongoose/repositories/identity"));

var _password = _interopRequireDefault(require("./mongoose/repositories/password"));

var _social = _interopRequireDefault(require("./mongoose/repositories/social"));

var _account2 = _interopRequireDefault(require("./mongoose/models/account"));

var _device2 = _interopRequireDefault(require("./mongoose/models/device"));

var _identity2 = _interopRequireDefault(require("./mongoose/models/identity"));

var _hash = _interopRequireDefault(require("./mongoose/models/hash"));

var _password2 = _interopRequireDefault(require("./mongoose/models/password"));

var _social2 = _interopRequireDefault(require("./mongoose/models/social"));

var mongoClass;

/**
 * Example config:
 * 
 * database : {
 *     library : "mongoose",
 *
 *     host : 'mongodb://deckathlon:deckathlon@localhost:27017/deckathlon'
 * }
 */
var Mongoose =
/*#__PURE__*/
function () {
  function Mongoose() {
    (0, _classCallCheck2.default)(this, Mongoose);
  }

  (0, _createClass2.default)(Mongoose, [{
    key: "getType",
    value: function getType() {
      return 'mongo';
    }
  }, {
    key: "getId",
    value: function getId(object) {
      return object._id;
    }
  }, {
    key: "repository",
    value: function repository(type) {
      switch (type) {
        case 'account':
          return (0, _account.default)();

        case 'device':
          return (0, _device.default)();

        case 'identity':
          return (0, _identity.default)();

        case 'password':
          return (0, _password.default)();

        case 'social':
          return (0, _social.default)();
      }
    }
  }, {
    key: "model",
    value: function model(_model) {
      switch (_model) {
        case 'account':
          return _account2.default;

        case 'device':
          return _device2.default;

        case 'identity':
          return _identity2.default;

        case 'password':
          return _password2.default;

        case 'hash':
          return _hash.default;

        default:
          console.error("Model type " + _model + " not found");
      }
    }
  }]);
  return Mongoose;
}();

function _default() {
  if (!mongoClass) mongoClass = new Mongoose();
  return mongoClass;
}