"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _mongoose = _interopRequireDefault(require("mongoose"));

var identitySchema = _mongoose.default.Schema({
  activated: {
    type: Boolean,
    default: true
  },
  enabled: {
    type: Boolean,
    default: true
  },
  blocked: Boolean,
  blocked_at: Date,
  created_at: Date,
  deleted_at: Date,
  updated_at: Date
});

identitySchema.pre('save', function (next) {
  var now = new Date();
  this.updated_at = now;

  if (!this.created_at) {
    this.created_at = now;
  }

  next();
});

var _default = _mongoose.default.model('auth_identity', identitySchema);

exports.default = _default;