"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _database = _interopRequireDefault(require("./../../../database"));

var _device = _interopRequireDefault(require("./../models/device"));

var deviceRepository;

var DeviceRepository =
/*#__PURE__*/
function () {
  function DeviceRepository() {
    (0, _classCallCheck2.default)(this, DeviceRepository);
  }

  (0, _createClass2.default)(DeviceRepository, [{
    key: "insert",
    value: function insert(data) {
      return new _bluebird.default(function (resolve) {
        return _device.default.create(data, function (err, result) {
          resolve(result);
        });
      });
    }
  }, {
    key: "update",
    value: function update(id, data) {
      var self = this;
      return new _bluebird.default(function (resolve) {
        _device.default.updateOne({
          '_id': id
        }, data, function () {
          self.findOneById(id).then(function (device) {
            resolve(device);
          });
        });
      });
    }
  }, {
    key: "findOneById",
    value: function findOneById(id) {
      return new _bluebird.default(function (resolve) {
        _device.default.findById(id).exec(function (err, result) {
          resolve(result);
        });
      });
    }
  }, {
    key: "findOneByDeviceId",
    value: function findOneByDeviceId(deviceId) {
      return new _bluebird.default(function (resolve) {
        _device.default.findOne({
          'device_id': deviceId
        }).exec(function (err, result) {
          resolve(result);
        });
      });
    }
  }, {
    key: "disableAllExceptThis",
    value: function disableAllExceptThis(device) {
      return new _bluebird.default(function (resolve) {
        _device.default.updateMany({
          "$and": [{
            '_id': {
              "$ne": (0, _database.default)().getId(device)
            }
          }, {
            'identity_id': device.identity_id
          }]
        }, {
          'disabled': true,
          'refresh_token': ''
        }, function () {
          resolve();
        });
      });
    }
  }, {
    key: "disableAll",
    value: function disableAll(identity) {
      return new _bluebird.default(function (resolve) {
        _device.default.updateMany({
          'identity_id': identity
        }, {
          'disabled': true,
          'refresh_token': ''
        }, function () {
          resolve();
        });
      });
    }
  }, {
    key: "findOneByDeviceIdAndIdentity",
    value: function findOneByDeviceIdAndIdentity(deviceId, identityId) {
      return new _bluebird.default(function (resolve) {
        _device.default.findOne({
          'device_id': deviceId,
          'identity_id': identityId
        }).exec(function (err, result) {
          resolve(result);
        });
      });
    }
  }]);
  return DeviceRepository;
}();

function _default() {
  if (!deviceRepository) deviceRepository = new DeviceRepository();
  return deviceRepository;
}