"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _typeorm = require("typeorm");

var _account = _interopRequireDefault(require("./typeorm/models/account"));

var _device = _interopRequireDefault(require("./typeorm/models/device"));

var _identity = _interopRequireDefault(require("./typeorm/models/identity"));

var _password = _interopRequireDefault(require("./typeorm/models/password"));

var _hash = _interopRequireDefault(require("./typeorm/models/hash"));

var _social = _interopRequireDefault(require("./typeorm/models/social"));

var _account2 = _interopRequireDefault(require("./typeorm/repositories/account"));

var _device2 = _interopRequireDefault(require("./typeorm/repositories/device"));

var _identity2 = _interopRequireDefault(require("./typeorm/repositories/identity"));

var _password2 = _interopRequireDefault(require("./typeorm/repositories/password"));

var _social2 = _interopRequireDefault(require("./typeorm/repositories/social"));

var ormClass;

/**
 * Example config:
 * 
 * database : {
 *    library : "typeorm",
 *
 *    username : 'root',
 *    password : 'ubuntu',
 *    database : 'mydatabase',
 *    type : 'mysql',
 *
 *    synchronize : true,
 *    logging : true
 *}
 */
var TypeORM =
/*#__PURE__*/
function () {
  function TypeORM() {
    (0, _classCallCheck2.default)(this, TypeORM);
  }

  (0, _createClass2.default)(TypeORM, [{
    key: "getType",
    value: function getType() {
      return 'typeorm';
    }
  }, {
    key: "getId",
    value: function getId(object) {
      return object.id;
    }
  }, {
    key: "repository",
    value: function repository(type) {
      switch (type) {
        case 'account':
          return (0, _account2.default)();

        case 'device':
          return (0, _device2.default)();

        case 'identity':
          return (0, _identity2.default)();

        case 'password':
          return (0, _password2.default)();

        case 'social':
          return (0, _social2.default)();

        default:
          console.error("Repository " + type + " not found");
          process.exit();
      }
    }
  }, {
    key: "model",
    value: function model(_model) {
      switch (_model) {
        case 'account':
          return _account.default;

        case 'device':
          return _device.default;

        case 'identity':
          return _identity.default;

        case 'password':
          return _password.default;

        case 'hash':
          return _hash.default;

        case 'social':
          return _social.default;

        default:
          console.error("Model type " + _model + " not found");
          process.exit();
      }
    }
  }, {
    key: "setData",
    value: function setData(model, data, array) {
      for (var column in array) {
        var defaultValue = array[column];
        if (typeof data[column] !== 'undefined') model[column] = data[column];else if (typeof model[column] === 'undefined') model[column] = defaultValue;
      }
    }
  }]);
  return TypeORM;
}();

function _default() {
  if (!ormClass) ormClass = new TypeORM();
  return ormClass;
}