"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _typeorm = require("typeorm");

var _device = _interopRequireDefault(require("./../models/device"));

var _database = _interopRequireDefault(require("./../../../database"));

var deviceRepository;

var DeviceRepository =
/*#__PURE__*/
function () {
  function DeviceRepository() {
    (0, _classCallCheck2.default)(this, DeviceRepository);
  }

  (0, _createClass2.default)(DeviceRepository, [{
    key: "insert",
    value: function insert(data) {
      var newDevice = new _device.default(0, data.identity_id, null, data.device_id);
      return (0, _typeorm.getManager)().save([newDevice]).then(function () {
        return newDevice;
      });
    }
  }, {
    key: "update",
    value: function update(id, data) {
      if (!id) return;
      var self = this;
      return (0, _typeorm.getManager)().createQueryBuilder().update(_device.default).set(data).where('id = :id', {
        id: id
      }).execute().then(function () {
        return self.findOneById(id);
      });
    }
  }, {
    key: "findOneById",
    value: function findOneById(id) {
      if (!id) return;
      return (0, _typeorm.getManager)().getRepository(_device.default).createQueryBuilder('device').where('device.id = :id', {
        id: id
      }).getOne();
    }
  }, {
    key: "findOneByDeviceId",
    value: function findOneByDeviceId(deviceId) {
      if (!deviceId) return;
      return (0, _typeorm.getManager)().getRepository(_device.default).createQueryBuilder('device').where('device.device_id = :id', {
        id: deviceId
      }).getOne();
    }
  }, {
    key: "disableAllExceptThis",
    value: function disableAllExceptThis(device) {
      if (!device) return;
      return (0, _typeorm.getManager)().createQueryBuilder().update(_device.default).set({
        'disabled': true,
        'refresh_token': ''
      }).where('id != :id', {
        id: (0, _database.default)().getId(device)
      }).andWhere('identity_id = :identity', {
        identity: device.identity_id
      }).execute();
    }
  }, {
    key: "disableAll",
    value: function disableAll(identity) {
      if (!identity) return;
      return (0, _typeorm.getManager)().createQueryBuilder().update(_device.default).set({
        'disabled': true,
        'refresh_token': ''
      }).where('identity_id = :identity', {
        identity: identity
      }).execute();
    }
  }, {
    key: "findOneByDeviceIdAndIdentity",
    value: function findOneByDeviceIdAndIdentity(deviceId, identityId) {
      if (!deviceId || !identityId) return;
      return (0, _typeorm.getManager)().getRepository(_device.default).createQueryBuilder('device').where('device.device_id = :id', {
        id: deviceId
      }).andWhere('device.identity_id = :identity', {
        identity: identityId
      }).getOne();
    }
  }]);
  return DeviceRepository;
}();

function _default() {
  if (!deviceRepository) deviceRepository = new DeviceRepository();
  return deviceRepository;
}