"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeorm = require("typeorm");

var _device = _interopRequireDefault(require("../models/device"));

module.exports = new _typeorm.EntitySchema({
  tableName: 'auth_device',
  name: 'Device',
  target: _device.default,
  columns: {
    id: {
      primary: true,
      type: 'int',
      generated: true
    },
    identity_id: {
      type: 'int',
      unsigned: true
    },
    refresh_token: {
      type: 'varchar',
      nullable: true
    },
    device_id: {
      type: 'varchar',
      nullable: true
    },
    device_type: {
      type: 'smallint',
      nullable: true
    },
    device_push: {
      type: 'varchar',
      nullable: true
    },
    device_language: {
      type: 'varchar',
      length: 4,
      nullable: true
    },
    is_guest: {
      type: 'smallint',
      default: 0
    },
    disabled: {
      type: 'smallint',
      default: 0
    },
    created_at: {
      type: 'timestamp',
      nullable: true
    }
  }
});