"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defineSettings = defineSettings;
exports.settingsByUrl = settingsByUrl;
exports.settingsByVersion = settingsByVersion;

var _lodash = _interopRequireDefault(require("lodash"));

function defineSettings(version, settings, versionSettings, defaultSettings) {
  if (!versionSettings['default']) versionSettings['default'] = defaultSettings;
  if (versionSettings[version]) return versionSettings;

  var thisSettings = _lodash.default.assign({}, defaultSettings, settings);

  version = createKey(version);
  versionSettings[version] = thisSettings;
  return versionSettings;
}

function settingsByUrl(req, settings) {
  var thisSettings = null;

  for (var version in settings) {
    if (version == 'default') continue;
    var v = version.replace('_', '.'),
        path = void 0;
    if (req.path) path = req.path;else if (req.originalUrl) path = req.get('host') + req.originalUrl;else path = '/';
    if (path.toString().match(new RegExp(v))) thisSettings = settings[version];
  }

  return thisSettings || settings.default;
}

function settingsByVersion(version, settings) {
  return settings[createKey(version)] || settings.default;
}

function createKey(version) {
  return version.replace('.', '_');
}