"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _lodash = _interopRequireDefault(require("lodash"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _database = _interopRequireDefault(require("./../../database"));

var _config = require("./../../config");

var _default =
/*#__PURE__*/
function () {
  function _default() {
    (0, _classCallCheck2.default)(this, _default);
    this.log = (0, _config.getConfig)('log');
  }

  (0, _createClass2.default)(_default, [{
    key: "user",
    value: function user(_user) {
      this.userObject = _user;
      return this;
    }
  }, {
    key: "device",
    value: function device(_device) {
      this.device = _device;
      return this;
    }
  }, {
    key: "create",
    value: function create(options) {
      options = options || {};
      options.id = options.id || 'web';
      var self = this,
          id = options.id;
      return (0, _database.default)().repository('device').findOneByDeviceIdAndIdentity(id, (0, _database.default)().getId(this.userObject.user)).then(function (device) {
        if (!device) {
          self.log('Device not found: ' + id);
          return (0, _database.default)().repository('device').insert({
            'identity_id': (0, _database.default)().getId(self.userObject.user),
            'device_id': id
          }).then(function (savedDevice) {
            self.log('Device uploaded');
            return savedDevice;
          }).catch(function (err) {
            throw err;
          });
        } else {
          self.log('Device found: ' + id);
          return device;
        }
      }).then(function (device) {
        self.device = device;
        return self.update(options);
      }).catch(function (err) {
        throw err;
      });
    }
  }, {
    key: "update",
    value: function update(options) {
      var self = this,
          update = {},
          deviceId = (0, _database.default)().getId(this.device);

      if (options.type) {
        if (options.type == 1 || options.type == 'ios') update.device_type = 1;else if (options.type == 2 || options.type == 'android') update.device_type = 1;
      }

      if (options.push) update.device_push = options['push'];
      if (options.language) update.device_language = options['language'];

      if (!_lodash.default.isEmpty(update) && deviceId) {
        return (0, _database.default)().repository('device').update(deviceId, update).then(function (device) {
          self.log('Device updated: ' + JSON.stringify(options));
          return device;
        });
      } else {
        return _bluebird.default.resolve(this.device);
      }
    }
  }]);
  return _default;
}();

exports.default = _default;